<?php
/**
 * @name srv_control.php
 * @description Fichier principal du plugin serveur
 * @author Nicolas Biersart <n.biersart@esia-sa.com>
 * @contributor
 * @copyright Nicolas Biersart 2012
 * @license
 * @esia 1.00
 * @version 1.0.0
 * @date 09/11/2012
 */

//inclusion des fichiers principaux
$path = $_SERVER['DOCUMENT_ROOT'];
include_once $path.'common.php';
include_once $path.'/Model_adm.php';
//on récupère le nom du serveur
/*DESCRIPTION: inclus les variables habituelles pour la gestion d'un noeud et vérifie les droits d'accès
 *NECESSITE: la variable $webp_name configurée
 *           la variable $webp_model est incluste
 *APRES l'inclusion du common_node_control les variables suivantes sont créées:
 *PHP:
 *      $node objet de type device
 *      $template_path chemin d'accès vers le répertoire template du plugin (exemple: /usr/local/esia/public_html/plugin/server/templates/)
 *      $apache_plugin_path chemin apache du plugin (exemple: /plugin/server/)
 *      $node_info = array('id'=>$node->getId(),
 'name'=>$node->getName(),
 'ip'=>$node->getIPAddress(),
 'id'=>$node->getId(),
 'description'=>$node->getDescription(),
 'group'=>$node->getGroup());
 * SMARTY
 $webp_name nom du plugin
 $node avec les donnée de node_info (voir au dessus)
 *      $apache_path chemin apache du plugin (exemple: /plugin/server/)
 *      $node_status pour l'affichage commun des noeuds si $_GET['tab'] est vide
 *
 */
$webp_name = 'Syslog';
include_once $path.'/inc/common_node_control.php';
include_once $path.$apache_plugin_path.'libs/syslog.class.php';
$tab = '';
if(isset($_GET['tab']) && !empty($_GET['tab']))
{
	$tab = $_GET['tab'];
}
$smarty->assign('tab', $tab);
session_write_close();
$adv_syslog = Model_adm::getAdvanceNodeConfig($dbconnection,$node->getId(),'SYSLOG')[0];
if(!empty($adv_syslog))
{
	$syslog = Model_esia::InstanceNode($dbconnection, $adv_syslog['parameter']['syslog-server']);
	$syslog = new SyslogServer($syslog);
	$setting = Model_adm::getAdvanceNodeConfig($dbconnection,$syslog->getId(),'SYSLOG_URL')[0];
	$syslog->setURL($setting['parameter']['url']); 
	$smarty->assign('syslog', array('id' => $syslog->getId(),'name' => $syslog->getName() ));
	$smarty->assign('syshost', $adv_syslog['parameter']['host']);
	$smarty->display($template_path.'adv_tab_syslog.html');
}
else
{
	$smarty->display('no_access.html');
	exit(0);
}
?>