<?php
/**
 * @name srv_control.php
 * @description Fichier principal du plugin serveur
 * @author Nicolas Biersart <n.biersart@esia-sa.com>
 * @contributor
 * @copyright Nicolas Biersart 2012
 * @license
 * @esia 1.00
 * @version 1.0.0
 * @date 09/11/2012
 */

//inclusion des fichiers principaux
$path = $_SERVER['DOCUMENT_ROOT'];
include_once $path.'common.php';
include_once $path.'/Model_adm.php';
//on récupère le nom du serveur
/*DESCRIPTION: inclus les variables habituelles pour la gestion d'un noeud et vérifie les droits d'accès
 *NECESSITE: la variable $webp_name configurée
 *           la variable $webp_model est incluste
 *APRES l'inclusion du common_node_control les variables suivantes sont créées:
 *PHP:
 *      $node objet de type device
 *      $template_path chemin d'accès vers le répertoire template du plugin (exemple: /usr/local/esia/public_html/plugin/server/templates/)
 *      $apache_plugin_path chemin apache du plugin (exemple: /plugin/server/)
 *      $node_info = array('id'=>$node->getId(),
 'name'=>$node->getName(),
 'ip'=>$node->getIPAddress(),
 'id'=>$node->getId(),
 'description'=>$node->getDescription(),
 'group'=>$node->getGroup());
 * SMARTY
 $webp_name nom du plugin
 $node avec les donnée de node_info (voir au dessus)
 *      $apache_path chemin apache du plugin (exemple: /plugin/server/)
 *      $node_status pour l'affichage commun des noeuds si $_GET['tab'] est vide
 *
 */
$webp_name = 'Syslog';
include_once $path.'/inc/common_node_control.php';
include_once $path.$apache_plugin_path.'libs/syslog.class.php';
$tab = '';
if(isset($_GET['tab']) && !empty($_GET['tab']))
{
	$tab = $_GET['tab'];
}
$action = '';
if(isset($_GET['action']) && !empty($_GET['action']))
{
	$action = $_GET['action'];
}
$smarty->assign('tab', $tab);
session_write_close();
try
{
	if($user->getDroits($dbconnection,"syslog_configuration",$node->getName()) == 1)
	{
		$smarty->assign('adm_syslog', 1);
	}
	if($tab == 'rules')
	{
		if($user->getDroits($dbconnection,"esia_device") == 1)
		{
			$smarty->assign('adm_access','1');
		}
		$node = new SyslogServer($node);
		$setting = Model_adm::getAdvanceNodeConfig($dbconnection,$node->getId(),'SYSLOG_URL')[0];
		$node->setURL($setting['parameter']['url']); 
		$arr = $node->getRules(NULL,SyslogServer::OUTPUT_ARRAY);
		$smarty->assign('syslog_rules', $arr);
		if(isset($_POST['rulelist']))
		{
			try
			{
				$conf = $node->setOrderRules($_POST['rulelist']);
				$arr['statut'] = 0;
				$arr['message'] = $lang['SYSLOG_CONFIGURATION_SUCCESS'];
				echo json_encode($arr);
			}
			catch(SyslogServerException $e)
			{
				$arr['statut'] = 1;   
				$arr['message'] = $e->getMessage();    
				echo json_encode($arr);
			}
			exit(0); 
		}
	}
	elseif($tab == 'configuration')
	{
		$subtab = $_GET['subtab'];
		$smarty->assign('subtab', $subtab);
		if($subtab == 'autoclean')
		{
			$node = new SyslogServer($node);
			$setting = Model_adm::getAdvanceNodeConfig($dbconnection,$node->getId(),'SYSLOG_URL')[0];
			$node->setURL($setting['parameter']['url']); 
			if($action == 'updateConf')
			{   
				$arr = array('emergency' => 365,'alert' => 365,'critical' => 365,'errors' => 365,'warning' => 30,'notice' => 2,'info' => 2,'debug' => 1);
				foreach($arr as $key => &$value)
				{
					if(isset($_POST[$key]) && !empty($_POST[$key]))
					{
						$value = $_POST[$key];
					}
				}
				try
				{
					$conf = $node->setConfiguration($arr);
					$arr['statut'] = 0;   
					$arr['message'] = $lang['SYSLOG_CONFIGURATION_SUCCESS'];    
					echo json_encode($arr);
				}
				catch(SyslogServerException $e)
				{
					$arr['statut'] = 1;   
					$arr['message'] = $e->getMessage();    
					echo json_encode($arr);
				}
				exit(0);      
			}
			$conf = $node->getConfiguration(SyslogServer::OUTPUT_ARRAY);
			$smarty->assign('syslog_conf', $conf);
		}
		elseif($subtab == 'node')
		{
			$syslog = new SyslogServer($node);
			$setting = Model_esia::getAdvanceNodeConfig($dbconnection,$syslog->getId(),'SYSLOG_URL')[0];
			$syslog->setURL($setting['parameter']['url']);
			$hosts = $syslog->getHosts(SyslogServer::OUTPUT_ARRAY);
			
			$advs = Model_esia::getAdvanceNodeConfigType($dbconnection,'SYSLOG')[0];
			$advs = Model_esia::getAdvanceNodeConfig($dbconnection,NULL,NULL,$advs['id']);
			$confnode = array();
			//print_r($advs);
			foreach($advs as $adv)
			{
				if($adv['parameter']['syslog-server'] == $syslog->getId())
				{
					$hostname = $adv['parameter']['host'];
					$confnode[$hostname] = array('id' => $adv['node_id'],'acquitte' => $adv['parameter']['during_alert']);
				}
			}
			$linknode = array();
			foreach($hosts as $host)
			{
				if(array_key_exists($host, $confnode))
				{
					$nodefound = $confnode[$host];
					$node = Model_esia::InstanceNode($dbconnection, $nodefound['id']);
					$page_control = Model_esia::getPageControl($dbconnection, $node->getType() );
					if($page_control != NULL)
					{
						$page_control = Model_esia::replacePageControlVariable($page_control,$node);
					}
					else
					{
						$page_control = '/node_view.php?nodeid='.$node->getId();
					}
					$linknode[] = array('syslog_name' => $host,
						'esia_id' => $node->getId(),
						'nodename' => $node->getName(),
						'pagecontrol' => $page_control,
						'acquitte' => $nodefound['acquitte'],
					);
				}
				else 
				{
					$linknode[] = array('syslog_name' => $host,
						'esia_id' => NULL,
						'nodename' => NULL,
						'pagecontrol' => NULL,
						'acquitte' => NULL
					);
				}
			}
			$smarty->assign('syslog_link_node', $linknode);
		}
	}
	else
	{
		$services = model_esia::getServices($dbconnection,$node->getId());
		$disk = array();
		$healthdata = false;
		$cpu= array('value'=>-1,'warning'=>100,'critical'=>100);
		$ram= array('value'=>-1,'warning'=>100,'critical'=>100);
		foreach($services as $ser)
		{
			if(strpos($ser['check_plugin_name'],'LOAD')!==FALSE)
			{
				if(preg_match('#\-w\s+([0-9]*)#',$ser['parameter'],$regs))
				{
					$cpu['warning']=$regs[1];
				}
				if(preg_match('#\-c\s+([0-9]*)#',$ser['parameter'],$regs))
				{
					$cpu['critical']=$regs[1];
				}
				$cpu['value']=$ser['value']['cpu'];
				$smarty->assign('cpu_information',$cpu);
			}
			elseif(strpos($ser['check_plugin_name'],'MEM')!==FALSE)
			{
				if(preg_match('#\-w\s+([0-9]*)#',$ser['parameter'],$regs))
				{
					$ram['warning']=$regs[1];
				}
				if(preg_match('#\-c\s+([0-9]*)#',$ser['parameter'],$regs))
				{
					$ram['critical']=$regs[1];
				}
				$ram['value']=$ser['value']['ram'];
			}
			elseif(strpos($ser['check_plugin_name'],'STORAGE')!==FALSE)
			{
				$common_name = Model_esia::getCommonName($lang,$ser['name'],$ser['check_plugin_name']);
				$disk[] = array('name'=>$common_name,'value'=> $ser['value']['hdd'],'state'=>$ser['real_state']);
			}
		}
		$smarty->assign('ram_information',$ram);
		$smarty->assign('disk_informations',$disk);
		$smarty->assign('cpu_information',$cpu);
	}
}
//Traitement des exceptions SNMP et des erreurs de traitement dans la base de donnée
catch(DeviceNotAliveException $e)
{
	$smarty->assign('errors','no');
}
catch(DeviceSNMPException $e)
{
	$smarty->assign('errors',$lang['ADM_ERR_SNMP_FAILED']);
}
catch(DeviceException $e)
{
	$smarty->assign('errors',$e->getMessage());
}
catch(SyslogServerException $e)
{
	$smarty->assign('errors',$e->getMessage());
}
$smarty->display($template_path.'control_syslog.html');
?>
