<?php
/**
 * @name srv_control.php
 * @description Fichier principal du plugin serveur
 * @author Nicolas Biersart <n.biersart@esia-sa.com>
 * @contributor
 * @copyright Nicolas Biersart 2012
 * @license
 * @esia 1.00
 * @version 1.0.0
 * @date 09/11/2012
 */

// inclusion des fichiers principaux

// $ESIA_WIDGET_NOTREE=TRUE;
$path = $_SERVER['DOCUMENT_ROOT'];
include_once $path . 'common.php';
include_once $path . '/Model_adm.php';
/*
 * DESCRIPTION: inclus les variables habituelles pour la gestion d'un noeud et vérifie les droits d'accès
 * NECESSITE: la variable $webp_name configurée
 * la variable $webp_model est incluste
 * APRES l'inclusion du common_node_control les variables suivantes sont créées:
 * PHP:
 * $node objet de type device
 * $template_path chemin d'accès vers le répertoire template du plugin (exemple: /usr/local/esia/public_html/plugin/server/templates/)
 * $apache_plugin_path chemin apache du plugin (exemple: /plugin/server/)
 * $node_info = array('id'=>$node->getId(),
 * 'name'=>$node->getName(),
 * 'ip'=>$node->getIPAddress(),
 * 'id'=>$node->getId(),
 * 'description'=>$node->getDescription(),
 * 'group'=>$node->getGroup());
 * SMARTY
 * $webp_name nom du plugin
 * $node avec les donnée de node_info (voir au dessus)
 * $apache_path chemin apache du plugin (exemple: /plugin/server/)
 * $node_status pour l'affichage commun des noeuds si $_GET['tab'] est vide
 *
 */
$webp_name = 'Syslog';
include_once $path . '/inc/common_node_control.php';
include_once $path . $apache_plugin_path . 'libs/syslog.class.php';

$smarty->assign('lang', $lang);
$action = 'add';
if(isset($_GET['action']))
{
	$action = $_GET['action'];
}
session_write_close();
if ($action == 'updateRule' || $action == 'addRule')
{
	try
	{
		$smarty->assign('action', $action);
		if (isset($_POST['id']) && ! empty($_POST['id']))
		{
			$params['name'] = $_POST['name'];
			if ($_POST['id'] == - 1)
			{
				$params['id'] = "";
			}
			else
			{
				$params['id'] = $_POST['id'];
			}
			$params['from_host'] = $_POST['host'];
			$params['message_contains'] = $_POST['message'];
			$params['match_number'] = $_POST['number'];
			// print_r($_POST['severity']);
			$tmp = "";
			foreach ($_POST['severity'] as $sev)
			{
				$tmp .= $sev . ',';
			}
			$tmp = rtrim($tmp, ',');
			$params['priority'] = json_encode($_POST['severity']);
			$params['time_between'] = $_POST['time'];
			$node = new SyslogServer($node);
			$setting = Model_adm::getAdvanceNodeConfig($dbconnection, $node->getId(), 'SYSLOG_URL')[0];
			$node->setURL($setting['parameter']['url']);
			try
			{
				$arr = $node->addRules($params, SyslogServer::OUTPUT_ARRAY);
				if (empty($arr))
				{
					$smarty->assign('rule', $params);
					$smarty->assign('errors', $lang['SYSLOG_ADD_RULE_FAILED']);
				}
				else
				{
					$smarty->assign('rule', $arr[0]);
				}
			}
			catch (SyslogServerException $e)
			{
				$smarty->assign('rule', $params);
				$smarty->assign('errors', $e->getMessage());
			}
			// $smarty->assign('rule',$arr[0]);
		}
		else
		{
			if ($action == 'addRule')
			{
				$rule = array(
					'id' => - 1,
					'name' => "",
					'from_host' => '',
					'message_contains' => '',
					'severity' => "",
					'match_number' => 1,
					'time_between' => '0');
				$smarty->assign('rule', $rule);
			}
			else
			{
				$node = new SyslogServer($node);
				$setting = Model_adm::getAdvanceNodeConfig($dbconnection, $node->getId(), 'SYSLOG_URL')[0];
				$node->setURL($setting['parameter']['url']);
				if (! empty($_GET['ruleid']))
				{
					$arr = $node->getRules($_GET['ruleid'], SyslogServer::OUTPUT_ARRAY);
					$smarty->assign('rule', $arr[0]);
				}
			}
		}
	}
	catch (SyslogServerException $e)
	{
		$smarty->assign('errors', $e->getMessage());
	}
}
elseif ($action == 'deleteRule')
{
	try
	{
		$smarty->assign('action', $action);
		$node = new SyslogServer($node);
		$setting = Model_adm::getAdvanceNodeConfig($dbconnection, $node->getId(), 'SYSLOG_URL')[0];
		$node->setURL($setting['parameter']['url']);
		if (isset($_POST['id']) && ! empty($_POST['id']))
		{
			$arr = $node->deleteRules($_POST['id'], SyslogServer::OUTPUT_ARRAY);
			$smarty->assign('success_delete', "ok");
		}
		else
		{
			if (! empty($_GET['ruleid']))
			{
				$arr = $node->getRules($_GET['ruleid'], SyslogServer::OUTPUT_ARRAY);
				$smarty->assign('rule', $arr[0]);
			}
		}
	}
	catch (SyslogServerException $e)
	{
		$smarty->assign('errors', $e->getMessage());
	}
}
elseif ($action == 'addLinkNode' || $action == 'updateLinkNode')
{
	$smarty->assign('action',$action);
	//dialog_syslog.php?action=addLinkNode&amp;nodeid={$node.id}&amp;host={$linknode.syslog_name|escape:'url'}3
	if(!empty($_POST['syslog_esia']) && $_POST['syslog_esia'] != 0)
	{
		$config = NULL;
		try
		{
			$_GET['host'] = $_POST['syslog_host'];
			$config = Model_adm::getAdvanceNodeConfig($dbconnection,$_POST['syslog_esia'],'SYSLOG')[0];
			if(empty($config))
			{
				$config = Model_adm::getAdvanceNodeConfigType($dbconnection,'SYSLOG')[0];
				$config['parameter']["host"] = $_POST['syslog_host'];
				$config['parameter']["syslog-server"] = $_POST['syslog_srv'];
				$config['parameter']["during_alert"] = $_POST['syslog_during'];
				$config['id'] = Model_adm::addAdvanceNodeConfig($dbconnection,$_POST['syslog_esia'],$config['id'],$config['parameter']);
				
			}
			else
			{
				$config = Model_adm::getAdvanceNodeConfig($dbconnection,$_POST['syslog_esia'],'SYSLOG')[0];
				$config['parameter']["host"] = $_POST['syslog_host'];
				$config['parameter']["syslog-server"] = $_POST['syslog_srv'];
				$config['parameter']["during_alert"] = $_POST['syslog_during'];
				Model_adm::updateAdvanceNodeConfig($dbconnection, $config['id'],json_encode($config['parameter']));
			}
			$_GET['esiaid'] = $_POST['syslog_esia'];
			$_GET['host'] = $_POST['syslog_host'];
			
			$smarty->assign('success',$lang['SYSLOG_SAVE_SUCCESS']);
		} 
		catch (Exception $e)
		{
			$smarty->assign('errors',$e->getMessage());
		}
	}
	if(!empty($_GET['nodeid']) && !empty($_GET['host']))
	{
		$smarty->assign('srv_syslog_id', $_GET['nodeid']);
		$smarty->assign('srv_syslog_host', $_GET['host']);
		$smarty->assign('alert',5);
		if(isset($_GET['esiaid']))
		{
			$config = Model_adm::getAdvanceNodeConfig($dbconnection,$_GET['esiaid'],'SYSLOG')[0];
			if(!empty($config))
			{
				$smarty->assign('esiaid',$_GET['esiaid']);
				$smarty->assign('alert',$config['parameter']["during_alert"]);
			}
		}
		$nodes = model_esia::getNodeList($dbconnection,$user->getId());
		$arr = array();
		foreach($nodes as $node)
		{
			//$arr[]=array('id'=>$node['id'],'name'=>$node['name']);
			$arr[$node['id']] = $node['name'];
		}
		$smarty->assign('listnode',$arr);
	}
}
elseif ($action == 'deleteLinkNode')
{
	try
	{
		$smarty->assign('action', $action);
		if (isset($_POST['id']) && ! empty($_POST['id']))
		{
			model_adm::deleteAdvanceNodeConfig($dbconnection, $_POST['id']);
			$smarty->assign('success_delete', "ok");
		}
		else 
		{
			if(isset($_GET['esiaid']))
			{
				$config = Model_adm::getAdvanceNodeConfig($dbconnection,$_GET['esiaid'],'SYSLOG')[0];
				if(!empty($config))
				{
					$node = Model_esia::InstanceNode($dbconnection, $_GET['esiaid']);
					$smarty->assign('esiaid',$node->getId());
					$smarty->assign('esianame',$node->getName());
					$smarty->assign('adv_config',$config['id']);
					$smarty->assign('alert',$config['parameter']["during_alert"]);
					$smarty->assign('srv_syslog_id', $_GET['nodeid']);
					$smarty->assign('srv_syslog_host', $_GET['host']);
				}
			}
		}
		
	}
	catch (SyslogServerException $e)
	{
		$smarty->assign('errors', $e->getMessage());
	}
}
$smarty->display($template_path . 'dialog_syslog.html');
?>
