<?php
// inclusion des fichiers principaux
$path = $_SERVER['DOCUMENT_ROOT'];
include_once $path . 'common.php';
include_once $path . '/Model_adm.php';
$severitycss = array(
	'emergency' => 'syslog_emergency',
	'alert' => 'syslog_alert',
	'critical' => 'syslog_critical',
	'errors' => 'syslog_errors',
	'warning' => 'syslog_warning',
	'notice' => 'syslog_notice',
	'info' => 'syslog_info',
	'debug' => 'syslog_debug');
/*
 * DESCRIPTION: inclus les variables habituelles pour la gestion d'un noeud et vérifie les droits d'accès
 * NECESSITE: la variable $webp_name configurée
 * la variable $webp_model est incluste
 * APRES l'inclusion du common_node_control les variables suivantes sont créées:
 * PHP:
 * $node objet de type device
 * $template_path chemin d'accès vers le répertoire template du plugin (exemple: /usr/local/esia/public_html/plugin/server/templates/)
 * $apache_plugin_path chemin apache du plugin (exemple: /plugin/server/)
 * $node_info = array('id'=>$node->getId(),
 * 'name'=>$node->getName(),
 * 'ip'=>$node->getIPAddress(),
 * 'id'=>$node->getId(),
 * 'description'=>$node->getDescription(),
 * 'group'=>$node->getGroup());
 * SMARTY
 * $webp_name nom du plugin
 * $node avec les donnée de node_info (voir au dessus)
 * $apache_path chemin apache du plugin (exemple: /plugin/server/)
 * $node_status pour l'affichage commun des noeuds si $_GET['tab'] est vide
 *
 */
$webp_name = 'Syslog';
include_once $path . '/inc/common_node_control.php';
include_once $path . $apache_plugin_path . 'libs/syslog.class.php';
$show = 'logbyday';
if (isset($_GET['show']) && ! empty($_GET['show']))
{
	$show = $_GET['show'];
}
try
{
	$node = new SyslogServer($node);
	$setting = Model_adm::getAdvanceNodeConfig($dbconnection, $node->getId(), 'SYSLOG_URL')[0];
	$node->setURL($setting['parameter']['url']);
	if ($show == 'logbyday')
	{
		$logdates = $node->getLogByDay();
		$logdates = array_reverse($logdates);
		$arr = array();
		$i = 0;
		$total = 0;
		foreach ($logdates as $line)
		{
			$date = date("d-m-Y", strtotime($line->date));
			$arr[$date] = $line->nbr;
			$total = $line->nbr + $total;
			if ($i >= 4)
			{
				break;
			}
			$i ++;
		}
		$final_arr['logbyday'] = $arr;
		$final_arr['total'] = number_format($total, 0, ',', ' ');
		$arrdata = array();
		$tophost = $node->top10HostByHour(24);
		foreach ($tophost as $line)
		{
			$arrdata[$line->host] = array(
				$line->nbr);
		}
		$final_arr['topdata'] = $arrdata;
		$severitys = $node->severityByHour(24, SyslogServer::OUTPUT_ARRAY);
		$final_arr['severity'] = $severitys;
		$hosts = $node->getHosts();
		$final_arr['host_total'] = count($hosts);
		echo json_encode($final_arr, JSON_NUMERIC_CHECK);
	}
	
	elseif ($show == 'logall')
	{
		$params = array();
		$day = 1;
		if (isset($_GET['day']) && ! empty($_GET['day']))
		{
			$day = $_GET['day'];
		}
		$params['page'] = 0;
		// Gestion du table sorter
		if (isset($_GET['page']) && ! empty($_GET['page']))
		{
			$params['page'] = $_GET['page'];
		}
		if (isset($_GET['size']) && ! empty($_GET['size']))
		{
			if ($_GET['size'] == 'all')
			{
				$_GET['size'] = 100;
			}
			$params['size'] = $_GET['size'];
		}
		if(!empty($_GET['syshost']))
		{
			$params['filter_host'] = ':'.$_GET['syshost'];
			foreach ($_REQUEST['filters'] as $num => $filter)
			{
				$filter = trim($filter);
				switch ($num)
				{
					case 0:
						$params['filter_date'] = $filter;
						break;
					case 1:
						$params['filter_severity'] = $filter;
						break;
					case 2:
						$params['filter_facility'] = $filter;
						break;
					case 3:
						$params['filter_message'] = $filter;
						break;
				}
			}
		}
		else
		{
			foreach ($_REQUEST['filters'] as $num => $filter)
			{
				$filter = trim($filter);
				switch ($num)
				{
					case 0:
						$params['filter_date'] = $filter;
						break;
					case 1:
						$params['filter_host'] = $filter;
						break;
					case 2:
						$params['filter_severity'] = $filter;
						break;
					case 3:
						$params['filter_facility'] = $filter;
						break;
					case 4:
						$params['filter_message'] = $filter;
						break;
				}
			}
		}
		$logs = $node->getLogsByDay($day, SyslogServer::OUTPUT_OBJECT, $params);
		// Count
		$arr = array();
		foreach ($logs->data as $line)
		{
			$tmp = array();
			$date = date("d-m-Y H:i:s", strtotime($line->date));
			$tmp[$lang['SYSLOG_TAB_DATE']] = $date;
			if(empty($_GET['syshost']))
			{
				$tmp[$lang['SYSLOG_TAB_HOST']] = $line->host;
			}
			$tmp[$lang['SYSLOG_TAB_SEVERITY']] = '<td class="' . $severitycss[$line->severity] . '">' . $line->severity . '</td>';
			$tmp[$lang['SYSLOG_TAB_FACILITY']] = $line->facility;
			$tmp[$lang['SYSLOG_TAB_MESSAGE']] = $line->message;
			$arr[] = $tmp;
		}
		$json_array['total_rows'] = $logs->total_logs;
		$json_array['headers'] = array_keys($arr[0]);
		$json_array['rows'] = $arr;
		echo json_encode($json_array);
	}
}
catch (SyslogServerException $e)
{
	echo json_encode(array(
		'error' => $e->getMessage()));
}
?>